theory Sample = PCL:

(* This is a useful option - it displays type information about variables *)
ML "set show_types"


(* This is about the simpliest thing we can prove. *)
lemma "MF(P, [send [[t::term]] ], X, Send(X,[[t]]))";
apply (clarify);
done;

(* We can use "by" for a terminal proof command instead of apply/done *)
lemma "MF(P, [receive [[t::term]]], X, Receive(X,[[t]]))";
by(rule AA1R);


(* The Contains predicate is very automated *)
lemma "Contains([[t::term, k::key]],[[t, n::nonce, k]])";
by (simp);


lemmas newLemma = P1S [where t="[[k::key]]"];
thm newLemma;

lemmas newSEQ = SEQ [where P="True" and X="<xx,s>"];
thm newSEQ;

(*
lemmas whywontSEQwork = SEQ [where Sa="(send ((t::term) ## []))" and Sb="[receive ((k::key) ## [])]"];
thm whywontSEQwork;
*)

lemma one: "MF( P, [send [[t::term]], receive [[k::key]]], X, (Send(X,[[t]]) & Receive(X,[[k]])))";
apply (rule SEQ);
apply (auto);
apply (rule G1);
apply (auto);
done;


lemma "MF( P, [send [[t::term]], receive [[k::key]]], X, (Send(X,[[t]]) & Receive(X,[[k]])))"
apply (rule G1);
apply (rule SEQ, auto)+;
done;


lemma "MF( P, [send [[t::term]], receive [[k::key]]], X, (Send(X,[[t]]) & Receive(X,[[k]])))"
apply (simp);
apply (rule_tac Sa="(send ((t::term) ## []))" and Sb="[receive ((k::key) ## [])]" in SEQ);
apply (rule AA1S);
apply (rule G1);
apply (rule P1S);
apply (rule AA1R);
done;

lemma "MF( P, [send [[t::term]], receive [[k::key]]], X, (Send(X,[[t]]) & Receive(X,[[k]])))";
apply (rule SEQ);
apply (rule AA1S);
apply (rule G1);
apply (rule P1S);
apply (rule AA1R);
done;

lemma "MF( P, [send [[t::term]], receive [[k::key]]], X, (Send(X,[[t]]) & Receive(X,[[k]])))";
(*apply (rule G1); *)
proof -;
	have "MF(P, [send [[t]]], X,Send(X,[[t]]))";
		by (rule AA1S);
	moreover
	have "MF(Send(X,[[t]]),[receive [[k]] ],X,Send(X, [[t]]) &  Receive(X,[[k]]))";
		apply (rule G1);
		apply (rule P1S);
		by (rule AA1R);
	ultimately show "MF( P, [send [[t]], receive [[k]]], X, Send(X, [[t]]) & Receive(X,[[k]]))";
		by (rule SEQ [where Sa="send [[t]]"]);
	qed;




lemma "MF( P, [send [[t::term]], receive [[k::key]]], X, (Send(X,[[t]]) & Receive(X,[[k]])))";
apply (rule SEQ [where Sa="(send [[t]])" ]);
apply (rule AA1S);
apply (rule G1);
apply (rule P1S);
apply (rule AA1R);
done;



