theory TermList = PCLTerm:

global

datatype TermListElem = 
	  Name name
	| Nonce nonce
	| Term "term"
	| Key key
	| Thread thread

types termlist = "TermListElem list"


syntax
	"" :: "termlist => term"	("_")


syntax
	ContainsGeneral	::	"['a::PCLTerm, TermListElem list] => bool" (infixr "IN" 70) 
(*
translations
	"(t::name) IN L" == "Name t mem L"
	"(t::nonce) IN L" == "Nonce t mem L"
	"(t::term) IN L" == "Term t mem L"
	"(t::key) IN L" == "Key t mem L"
	"(t::thread) IN L" == "Thread t mem L"
*)

consts
	ConsTermList	:: "['a::PCLTerm, TermListElem list] => TermListElem list" (infixr "##" 75) 

defs
	NameList_def:	"(t::name) ## L == (Name t) # L"
	NonceList_def:	"(t::nonce) ## L == (Nonce t) # L"
	TermList_def:	"(t::term) ## L == (Term t) # L"
	KeyList_def:	"(t::key) ## L == (Key t) # L"
	ThreadList_def:	"(t::thread) ## L == (Thread t) # L"

declare NameList_def[simp]
declare NonceList_def[simp]
declare TermList_def[simp]
declare KeyList_def[simp]
declare ThreadList_def[simp]

translations
	"[[ x, xs ]]" == "x ## [[xs]]"
	"[[x]]" == "x ## []"
(*
syntax
	AppendTermList	::	"[termlist, termlist] => termlist" (infixl "@@" 75)
*)	

constdefs
	ContainsPred	::	"[termlist,termlist] => bool"		("Contains'(_,_')")
		"(ContainsPred (L1::termlist) (L2::termlist)) == (set L1) <= (set L2)"

declare ContainsPred_def[simp]

end

