Cord = FOL +

global

types
	formula
	modal
	thread
	term
	actionFormula
	persist
	
	action
	strand
	cord
(*	name *)

	termlist

arities
	modal, cord, thread	::logic	
(*	
consts
	Trueprop2	::modal =>prop				(" _" 8)
*)	

consts


(*
	fakethread	::thread				("p")*)
	fakeformula	:: formula				("fo" )
	fakecord        :: cord             ("[CORD]")
(*	fakeo		:: o					("Othello")
	fakemodal	:: modal				("Modal")
	fakename	:: name					("H") 
*)
(*
	FakeTerm::	term				("t")
*)	

	TermUnit	:: idts =>	termlist		("_" 60)
	TermList	:: [termlist, termlist] => termlist ("_ , _" [60, 40] 40)
	Term		:: termlist => term		("_" 60)
	Thread		:: [idts, idts] => idts			("<_,_>" 60)
	Enc		:: [idts,term] => termlist		("ENC[_]'(_')" 60)
	Sig		:: [idts,term] => termlist		("SIG[_]'(_')" 60)
	Parens		:: term => term				("'(_')" )

(*special connectives for terms*)

	PEqual		:: [idts, idts] => o		("Equal'(_,_')")

(* cord calculus *)

	Noop		:: strand				("noop" 60)
	ActionSend	:: term => strand		("send _" 60)
	ActionReceive	::	term => strand	("receive _" 60)
	ActionNew	::	term => strand		("new _" 60)
	ActionMatch	::	[term, term] => strand		("match [_][_]" 60)
	StrandList	::  [strand, strand] => strand		("_;_" [60, 40] 40)

	
	Cord 		:: [idts, term, strand] => cord	("_ '( _ ') [ _ ]")
	
	(*Action Formulas*)


	PSend		::[idts, term] => actionFormula	("Send'(_,_')")
	PReceive		::[idts, term] => actionFormula	("Receive'(_,_')")
  	PNew             :: [idts, term] => actionFormula              ("New'(_,_')")
   	 PDecrypt         :: [idts, term] => actionFormula              ("Decrypt'(_,_')")
   	 PVerify          :: [idts, term] => actionFormula              ("Verify'(_,_')")

	(*Persist formulas*)

	PHas                     :: [idts, term] => formula            ("Has'(_,_')" 70)	
	PFirstSend       :: [idts, term] => formula      ("FirstSend'(_,_')" 70)	

	(*formulas*)

    PPrevious        :: [actionFormula, actionFormula] => formula            ("_ < _" 70)
    PFresh           :: [idts, term] => formula            ("Fresh'(_,_')" 70) 
    PHonest          :: idts => formula                                      ("Honest'(_')" 70)
    PContains        :: [term, term] => formula                      ("Contains'(_,_')" 70)
    PStart           ::      idts => formula                               ("Start'(_')" 70)

	
	ModalFormula	:: [o, cord, o]=> prop	 	("{_, _, _}" 90) 
	

	F2o :: formula => o ("_")
	A2F :: actionFormula => formula	("_")


rules



	(*Axioms for Protocol Actions*) 
	AA1S	"{P, Cord(X, t, ActionSend(A)), F2o(A2F(PSend(X,A)))}"   
	AA1R	"{P, Cord(X, t, ActionReceive(A)), F2o(A2F(PReceive(X,A)))}"
	AA1N	"{P, Cord(X, t, ActionNew(A)), F2o(A2F(PNew(X,A)))}"
	AA1V	"{P, Cord(X, t, ActionMatch(A, B)), F2o(A2F(PVerify(X,B)))}"


	AA2		"{F2o(PStart(X)), Cord(A,term,Noop), ~F2o(A2F(ActionPredicate))}"
	
	ARP		"{F2o(A2F(PReceieve(X,x))), Cord(X,t,ActionMatch(A,B)), F2o(A2f(PReceive(X,B)))}"

(* NEED TO FIX - EQUALITY PROBLEM*)
(* Cord(X, t, ActionNew(Term(TermUnit(x)))) *)
	AN2	"{P, Cord(X, t, ActionNew(x)), F2o(PHas(Y,x)) --> Equal(X,Y)}"


	AN3	"{P, Cord(X, t, ActionNew(x)), F2o(PFresh(X,x))}"

	SEC	"{P, C, Honest(X) & Decrypt(Y, ENC[X](x)) --> Equal(Y,X)}"

	VER	"((F2o(PHonest(X)) &  ~PEqual(Y,X)) & F2o(A2F(PVerify(Thread(Y, sig1), Z))))--> F2o(A2F(PSend(Thread(X, sig2), Z)))"

(* Possession Axioms *)
	ORIG	"{P, C, New(X,x) --> Has(X,x)}"
	REC	"{P, C, Receive(X,x) --> Has(X,x)}"
	TUP	"{P, C, Has(X,x) & Has(X,y) --> Has(X,x,y)}"
	ENC	"{P, C, Has(X,x) & Has(X,K) --> Has(X,ENC[K](x))}"
	PROJ	"{P, C, Has(X,x,y) --> Has(X,x) & Has(X,y)}"
	DEC	"{P, C, Has(X, ENC[K](x)) & Has(X,K) --> Has(X,x)}"

(*Generic rules*)
	G1	"[| {C, D, E}; {C, D, F} |] ==> {C, D, E & F}"
	G2      "[| {P , C , Q}; P-->P1; Q-->Q1 |] ==> {P1 , C , Q1}"
        G3      "Q ==> {P , C , Q}"		
	

(*Sequencing Rule*)

	SEQ		"[| {A, Cord(X, T::term, S::strand), B}; {B, Cord(X, T, S1::strand), C}|] ==> {A, Cord(X, T, StrandList(S,S1)::strand), C}" 

(*Preservation Axioms*)
	(*
	P1		"{F2o(P2F(A::persist)), Cord(X, T, U), F2o(P2F(A))}"	
	
	P1S		"{F2o(P2F(A::persist)), Cord(X, T, ActionSend(B::term)), F2o(P2F(A))}"
	P1R		"{F2o(P2F(A::persist)), Cord(X, T, ActionReceive(B::term)), F2o(P2F(A))}"
	P1N		"{F2o(P2F(A::persist)), Cord(X, T, ActionNew(B::term)), F2o(P2F(A))}"
	P1V		"{F2o(P2F(A::persist)), Cord(X, T, ActionMatch(B::term)), F2o(P2F(A))}" 
	*)

	P1S	"{F2o(A2F(PSend(X,A))), C, F2o(A2F(PSend(X,A)))}"
	P1R	"{F2o(A2F(PReceive(X,A))), C, F2o(A2F(PReceive(X,A)))}"
	P1N	"{F2o(A2F(PNew(X,A))), C, F2o(A2F(PNew(X,A)))}"
	P1V	"{F2o(A2F(PVerify(X,A))), C, F2o(A2F(PVerify(X,A)))}"
	P1H	"{F2o(PHas(X,A)), C, F2o(PHas(X,A))}"
	P1FS	"{F2o(PFirstSend(X,A)), C, F2o(PFirstSend(X,A))}"

	P2	"{F2o(PFresh(X, x)), Cord(X, T, U), F2o(PFresh(X, x))}"


(*Axioms for Temporal Ordering-- needs changing*)
	
	FS1	"{F2o(PFresh(X, t)), Cord(X, term, ActionSend(A::term)), F2o(P2F(PFirstSend(X, T)))}"

	FS2S	"F2o(PFirstSend(X,t1)) & F2o(A2F(PSend(Y, t3))) --> F2o(PPrevious(PSend(X, t2), PSend(Y,t3)))"
	FS2R	"F2o(PFirstSend(X,t1)) & F2o(A2F(PReceive(Y, t3))) --> F2o(PPrevious(PSend(X, t2), PReceive(Y,t3)))"
	FS2N	"F2o(PFirstSend(X,t1)) & F2o(A2F(PNew(Y, t3))) --> F2o(PPrevious(PSend(X, t2), PNew(Y,t3)))"
	FS2D	"F2o(PFirstSend(X,t1)) & F2o(A2F(PDecrypt(Y, t3))) --> F2o(PPrevious(PSend(X, t2), PDecrypt(Y,t3)))"
	FS2V	"F2o(PFirstSend(X,t1)) & F2o(A2F(PVerify(Y, t3))) --> F2o(PPrevious(PSend(X, t2), PVerify(Y,t3)))"


(*extra "<" rules *)

	LESS1	"F2o(PPrevious(A, B)) ==> F2o(A2F(A))"
	LESS2	"F2o(PPrevious(A, B)) ==> F2o(A2F(B))"

	HON1	"F2o(P)"


end
