(*ML "add_path\"~/pcl\""; *)
ML "set show_types"
ML "set show_sorts"

theory proof_CR1 = BasicSubset:;


lemma HON1: "Honest(Y) -->  ((Send(<Y,s>, m) & Contains(m, SIG[key(Y)](y,x,na(X)))) --> (Receive(<Y,s>,(x, na(X), na(Y))) < Send(<Y,s>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))))";
apply (rule HON);
apply (rule G3, rule AA2S, blast+);
apply (rule G3, rule P1P, blast+)+;

lemma HON1: "Honest(Y) -->  ((Send(<Y,s>, m) & Contains(m, SIG[key(Y)](y,x,na(X)))) --> (Receive(<Y,s>,(x, na(X), na(Y))) < Send(<Y,s>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))))";
apply (rule HON);
proof -;
  have a: "{Start(<Y,s>), <Y,s>[noop], ~Send(<Y,s>, m)}" by (rule AA2S);
  then show ONE: "{Start(<Y,s>),<Y,s>[noop], Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) --> Receive(<Y,s>,(x, na(X), na(Y))) < Send(<Y,s>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))}"; 
    apply (rule G3);
    apply blast;
    apply blast;
    done;
  next; have b: "{Receive(<Y,s>,(x, na(X), na(Y))) < Send(<Y,s>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))), <Y,s>[new y; send na(Y), na(X), y], Receive(<Y,s>,(x, na(X), na(Y))) < Send(<Y,s>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))}" by (rule P1P);
    then show TWO: "{Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) -->
     Receive(<Y,s>,(x, na(X), na(Y))) < Send(<Y,s>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))),<Y,s>[new y;send na(Y) , na(X) , y],Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) --> Receive(<Y,s>,(x, na(X), na(Y))) < Send(<Y,s>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))}";
      apply (rule G3);
      apply blast;
      apply blast;
      done;
    next;
      have c: "{Receive(<Y,s>,(x, na(X), na(Y))) < Send(<Y,s>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))),<Y,s>[receive (x, na(X), na(Y)) , z;match z / SIG[key(X)](x , y , na(Y))], Receive(<Y,s>,(x, na(X), na(Y))) < Send(<Y,s>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))}" by (rule P1P);   
      then show THREE: "{Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) --> Receive(<Y,s>,(x, na(X), na(Y))) < Send(<Y,s>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))),<Y,s>[receive (x, na(X), na(Y)) , z;match z / SIG[key(X)](x , y , na(Y))],Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) --> Receive(<Y,s>,(x, na(X), na(Y))) < Send(<Y,s>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))}"; 
	apply (rule G3);
	apply blast;
v	apply blast;
	done;
      next;
	have d: "{Receive(<Y,s>,(x, na(X), na(Y))) < Send(<Y,s>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))),<Y,s>[receive (x, na(X), na(Y));new y;send (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))], Receive(<Y,s>,(x, na(X), na(Y))) < Send(<Y,s>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))}" by (rule P1P);
	then show FOUR: "{Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) --> Receive(<Y,s>,(x, na(X), na(Y))) < Send(<Y,s>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))),<Y,s>[receive (x, na(X), na(Y));new y;send (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))],Send(<Y,s>,m) & Contains(m,SIG[key(Y)](y , x , na(X))) --> Receive(<Y,s>,(x, na(X), na(Y))) < Send(<Y,s>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))}";
	  apply (rule G3);
	  apply blast;
	  apply blast;
	  done;
	qed;

lemma HON2: "Honest(Y) --> (Send(<Y,s>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) --> FirstSend(<Y,s>, y, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))";
apply (rule HON);
proof -;
  have a: "{Start(<Y,s>),<Y,s>[noop],~Send(<Y,s>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))}" by (rule AA2S);
  then show ONE: "{Start(<Y,s>),<Y,s>[noop],Send(<Y,s>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) --> FirstSend(<Y,s>,y , (y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))}";
    apply (rule G3);
    apply blast;
    apply blast;
    done;
  next;
    have b: "{FirstSend(<Y,s>,y , (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))), <Y,s>[new y; send na(Y), na(X), y], FirstSend(<Y,s>,y , (y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))}" by (rule P1F);
    then show TWO: "{Send(<Y,s>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) --> FirstSend(<Y,s>,y , (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))),<Y,s>[new y;send na(Y) , na(X) , y],Send(<Y,s>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) --> FirstSend(<Y,s>,y , (y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))}";
      apply (rule G3);
      apply blast;
      apply blast;
      done;
    next;
      have c: "{FirstSend(<Y,s>,y , (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))),<Y,s>[receive (x, na(X), na(Y)) , z;match z / SIG[key(X)](x , y , na(Y))], FirstSend(<Y,s>,y , (y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))}" by (rule P1F);
      then show THREE: "{Send(<Y,s>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) --> FirstSend(<Y,s>,y , (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))),<Y,s>[receive (x, na(X), na(Y)) , z;match z / SIG[key(X)](x , y , na(Y))],Send(<Y,s>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) --> FirstSend(<Y,s>,y , (y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))}";
	apply (rule G3);
	apply blast;
	apply blast;
	done;
      next;
	have d: "{FirstSend(<Y,s>,y , (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))), <Y,s>[receive (x, na(X), na(Y));new y;send (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))], FirstSend(<Y,s>,y , (y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))}" by (rule P1F);
	then show FOUR: "{Send(<Y,s>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) --> FirstSend(<Y,s>,y , (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))),<Y,s>[receive (x, na(X), na(Y));new y;send (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))],Send(<Y,s>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) --> FirstSend(<Y,s>,y , (y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))}";
	  apply (rule G3);
	  apply blast;
	  apply blast;
	  done;
	qed;

theorem CR1: "{P, <X,s1>[new x; send (x, na(X), na(Y)); receive na(Y),na(X),y,z; match z/SIG[key(Y)](y,x,na(X))], (Honest(Y) & Y ~= X) --> (EX s2. (Send(<X,s1>,(x, na(X), na(Y))) < Receive(<Y, s2>, (x, na(X), na(Y)))) & (Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))) & (Send(<Y,s2>, na(Y), na(X), y, SIG[key(Y)](y, x, na(X))) < Receive(<X,s1>, na(Y), na(X), y, SIG[key(Y)](y, x, na(X)))))}";

proof -;
  have ONE: "{P | ~ P, <X,s1>[match z/SIG[key(Y)](y,x,na(X))], Verify(<X,s1>, SIG[key(Y)](y,x,na(X)))}" by (rule AA1V);
  have VERi: "(Honest(Y) & Verify(<X, s1>, SIG[key(Y)](y, x, na(X))) & Y ~= X) --> ((Send(<Y,s2>, u) & Contains(u, SIG[key(Y)](y, x, na(X)))))" by (rule VER);
  from VERi have i1: "Verify(<X, s1>, SIG[key(Y)](y, x, na(X))) --> (Honest(Y) & Y ~=X --> ((Send(<Y,s2>, u) & Contains(u , SIG[key(Y)](y, x, na(X))))))" by blast;
  have TAUT: "P | ~ P --> P | ~ P" by blast;
  from ONE TAUT i1 have TWO: "{P | ~ P, <X,s1>[match z/SIG[key(Y)](y,x,na(X))], Honest(Y) & Y ~=X --> ((Send(<Y,s2>, u) & Contains(u , SIG[key(Y)](y, x, na(X)))))}" by (rule G3);
  have THREE: "Honest(Y) --> (Send(<Y,s2>, u) & Contains(u , SIG[key(Y)](y,x,na(X))) --> Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))" by (rule HON1);
  then have THREEa: "(Honest(Y) & (Send(<Y,s2>, u) & Contains(u , SIG[key(Y)](y,x,na(X))))) --> Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))" by blast;
  then have MODTHREE: "{P | ~ P, <X,s1>[match z/SIG[key(Y)](y,x,na(X))],(Honest(Y) & (Send(<Y,s2>, u) & Contains(u , SIG[key(Y)](y,x,na(X))))) --> Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))}" by (rule G4);
  from MODTHREE TWO have TWOANDTHREE: "{P | ~ P, <X,s1>[match z/SIG[key(Y)](y,x,na(X))],((Honest(Y) & (Send(<Y,s2>, u) & Contains(u , SIG[key(Y)](y,x,na(X))))) --> Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))) & (Honest(Y) & Y ~=X --> ((Send(<Y,s2>, u) & Contains(u , SIG[key(Y)](y, x, na(X))))))}" by (rule G1);
  have int1: "(((Honest(Y) & (Send(<Y,s2>, u) & Contains(u , SIG[key(Y)](y,x,na(X))))) --> Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))) & (Honest(Y) & Y ~=X --> ((Send(<Y,s2>, u) & Contains(u , SIG[key(Y)](y, x, na(X))))))) --> ((Honest(Y) & Y ~= X) --> Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))" by blast;
  from TWOANDTHREE TAUT int1 have FOUR: "{P | ~ P, <X,s1>[match z/SIG[key(Y)](y,x,na(X))],((Honest(Y) & Y ~= X) --> Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))}" by (rule G3);
  have TAUT2: "P | ~P" by blast;
  then have int2: "{P | ~P, <X,s1>[receive na(Y), na(X), y, z], P | ~ P}" by (rule G4);
  from int2 FOUR have int3: "{P | ~P, <X,s1>[receive na(Y), na(X), y, z;match z/SIG[key(Y)](y,x,na(X))], ((Honest(Y) & Y ~= X) --> Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))}" by (rule SEQ);
  from TAUT2 have int4: "{Fresh(<X,s1>, x), <X,s1>[send (x, na(X), na(Y))], P | ~P}" by (rule G4);
  from int4 int3 have FIVE: "{Fresh(<X,s1>, x), <X,s1>[send (x, na(X), na(Y)); receive na(Y), na(X), y, z;match z/SIG[key(Y)](y,x,na(X))], ((Honest(Y) & Y ~= X) --> Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))}" by (rule SEQ);
  have int5: "Contains((x, na(X), na(Y)), x)"; by (rule S2);
  then have int6: "{Fresh(<X, s1>, x), <X, s1>[send (x, na(X), na(Y))], FirstSend(<X, s1>,x,(x, na(X), na(Y)))}" by (rule FS1);
  have int7: "{FirstSend(<X, s1>,x,(x, na(X), na(Y))), <X,s1>[receive na(Y), na(X), y, z;match z/SIG[key(Y)](y,x,na(X))], FirstSend(<X, s1>,x,(x, na(X), na(Y)))}" by (rule P1F);
  from int6 int7 have SIX: "{Fresh(<X,s1>, x), <X,s1>[send (x, na(X), na(Y)); receive na(Y), na(X), y, z;match z/SIG[key(Y)](y,x,na(X))], FirstSend(<X, s1>,x,(x, na(X), na(Y)))}" by (rule SEQ);
  have int8: "(Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))) --> (Receive(<Y,s2>, (x, na(X), na(Y))) & Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))" by (rule ACT);
  have TAUT3: "Fresh(<X,s1>, x) --> Fresh(<X,s1>, x)"; by blast;
  from int8 have int9: "((Honest(Y) & Y ~= X) --> Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))) --> ((Honest(Y) & Y ~= X) --> (Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) & (Receive(<Y,s2>, (x, na(X), na(Y))) & Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))))" by blast;
  from FIVE TAUT3 int9 have int10: "{Fresh(<X,s1>, x), <X,s1>[send (x, na(X), na(Y)); receive na(Y), na(X), y, z;match z/SIG[key(Y)](y,x,na(X))], ((Honest(Y) & Y ~= X) --> (Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) & (Receive(<Y,s2>, (x, na(X), na(Y))) & Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))))}" by (rule G3);
  from int10 SIX have FIVEANDSIX: "{Fresh(<X,s1>, x), <X,s1>[send (x, na(X), na(Y)); receive na(Y), na(X), y, z;match z/SIG[key(Y)](y,x,na(X))], ((Honest(Y) & Y ~= X) --> (Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) & (Receive(<Y,s2>, (x, na(X), na(Y))) & Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))))  & FirstSend(<X, s1>,x,(x, na(X), na(Y)))}" by (rule G1);
  from int5 have int11: "FirstSend(<X, s1>,x,(x, na(X), na(Y))) & Receive(<Y,s2>, (x, na(X), na(Y))) --> Send(<X,s1>, (x,na(X), na(Y))) < Receive(<Y,s2>, (x, na(X), na(Y)))" by (rule FS2R);
  then have SIXplus: "{Fresh(<X,s1>, x), <X,s1>[send (x, na(X), na(Y)); receive na(Y), na(X), y, z;match z/SIG[key(Y)](y,x,na(X))], FirstSend(<X, s1>,x,(x, na(X), na(Y))) & Receive(<Y,s2>, (x, na(X), na(Y))) --> Send(<X,s1>, (x,na(X), na(Y))) < Receive(<Y,s2>, (x, na(X), na(Y)))}" by (rule G4);
  from FIVEANDSIX SIXplus have FASplus: "{Fresh(<X,s1>, x), <X,s1>[send (x, na(X), na(Y)); receive na(Y), na(X), y, z;match z/SIG[key(Y)](y,x,na(X))], (((Honest(Y) & Y ~= X) --> (Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) & (Receive(<Y,s2>, (x, na(X), na(Y))) & Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))))  & FirstSend(<X, s1>,x,(x, na(X), na(Y)))) & (FirstSend(<X, s1>,x,(x, na(X), na(Y))) & Receive(<Y,s2>, (x, na(X), na(Y))) --> Send(<X,s1>, (x,na(X), na(Y))) < Receive(<Y,s2>, (x, na(X), na(Y))))}" by (rule G1);
  have int12: "((((Honest(Y) & Y ~= X) --> (Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) & (Receive(<Y,s2>, (x, na(X), na(Y))) & Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))))  & FirstSend(<X, s1>,x,(x, na(X), na(Y)))) & (FirstSend(<X, s1>,x,(x, na(X), na(Y))) & Receive(<Y,s2>, (x, na(X), na(Y))) --> Send(<X,s1>, (x,na(X), na(Y))) < Receive(<Y,s2>, (x, na(X), na(Y))))) --> ((Honest(Y) & Y ~= X) --> (Send(<X,s1>, (x,na(X), na(Y))) < Receive(<Y,s2>, (x, na(X), na(Y))) & Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))))" by blast;
  from FASplus TAUT3 int12 have SEVEN: "{Fresh(<X,s1>, x), <X,s1>[send (x, na(X), na(Y)); receive na(Y), na(X), y, z;match z/SIG[key(Y)](y,x,na(X))], ((Honest(Y) & Y ~= X) --> (Send(<X,s1>, (x,na(X), na(Y))) < Receive(<Y,s2>, (x, na(X), na(Y))) & Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))))}" by (rule G3);
  have EIGHT: "{P | ~P, <X,s1>[new x], Fresh(<X,s1>, x)}" by (rule AN3);
  from EIGHT SEVEN have NINE: "{P | ~P, <X,s1>[new x; send (x, na(X), na(Y)); receive na(Y), na(X), y, z;match z/SIG[key(Y)](y,x,na(X))], ((Honest(Y) & Y ~= X) --> (Send(<X,s1>, (x,na(X), na(Y))) < Receive(<Y,s2>, (x, na(X), na(Y))) & Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))))}" by (rule SEQ);
  have TEN: "Honest(Y) --> (Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) --> FirstSend(<Y,s2>, y, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))" by (rule HON2);
  have i13: "Contains((y, na(Y), na(X), SIG[key(Y)](y,x,na(X))), y)" by (rule S2);
  from i13 have i14: "(FirstSend(<Y,s2>, y, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) & Receive(<X,s1>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))) --> (Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) < Receive(<X,s1>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))" by (rule FS2R);
  from TEN i14 have i15: "(Honest(Y) --> (Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) --> FirstSend(<Y,s2>, y, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))) & ((FirstSend(<Y,s2>, y, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) & Receive(<X,s1>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))) --> (Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) < Receive(<X,s1>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))))" by blast;
  then have i16: "{P | ~P, <X,s1>[new x; send (x, na(X), na(Y)); receive na(Y), na(X), y, z;match z/SIG[key(Y)](y,x,na(X))],(Honest(Y) --> (Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) --> FirstSend(<Y,s2>, y, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))) & ((FirstSend(<Y,s2>, y, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) & Receive(<X,s1>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))) --> (Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) < Receive(<X,s1>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))))}" by (rule G4);
  from NINE i16 have i17: "{P | ~P, <X,s1>[new x; send (x, na(X), na(Y)); receive na(Y), na(X), y, z;match z/SIG[key(Y)](y,x,na(X))], ((Honest(Y) & Y ~= X) --> (Send(<X,s1>, (x,na(X), na(Y))) < Receive(<Y,s2>, (x, na(X), na(Y))) & Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))) & ((Honest(Y) --> (Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) --> FirstSend(<Y,s2>, y, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))) & ((FirstSend(<Y,s2>, y, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) & Receive(<X,s1>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))) --> (Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) < Receive(<X,s1>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))))}" by (rule G1);
  have i18: "Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) --> (Receive(<Y,s2>, (x, na(X), na(Y))) & Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))" by (rule ACT);
  then have i19: "(((Honest(Y) & Y ~= X) --> (Send(<X,s1>, (x,na(X), na(Y))) < Receive(<Y,s2>, (x, na(X), na(Y))) & Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))) & ((Honest(Y) --> (Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) --> FirstSend(<Y,s2>, y, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))) & ((FirstSend(<Y,s2>, y, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) & Receive(<X,s1>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))) --> (Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) < Receive(<X,s1>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))))) --> (((Honest(Y) & Y ~= X) --> (Send(<X,s1>, (x,na(X), na(Y))) < Receive(<Y,s2>, (x, na(X), na(Y))) & Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) & (Receive(<Y,s2>, (x, na(X), na(Y))) & Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))))) & ((Honest(Y) --> (Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) --> FirstSend(<Y,s2>, y, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))) & ((FirstSend(<Y,s2>, y, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) & Receive(<X,s1>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))) --> (Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) < Receive(<X,s1>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))))))" by blast;
  from i17 TAUT i19 have i20: "{P | ~P, <X,s1>[new x; send (x, na(X), na(Y)); receive na(Y), na(X), y, z;match z/SIG[key(Y)](y,x,na(X))], (((Honest(Y) & Y ~= X) --> (Send(<X,s1>, (x,na(X), na(Y))) < Receive(<Y,s2>, (x, na(X), na(Y))) & Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) & (Receive(<Y,s2>, (x, na(X), na(Y))) & Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))))) & ((Honest(Y) --> (Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) --> FirstSend(<Y,s2>, y, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))) & ((FirstSend(<Y,s2>, y, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) & Receive(<X,s1>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))) --> (Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) < Receive(<X,s1>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))))))}" by (rule G3); 
  have i18: "(((Honest(Y) & Y ~= X) --> (Send(<X,s1>, (x,na(X), na(Y))) < Receive(<Y,s2>, (x, na(X), na(Y))) & Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) & (Receive(<Y,s2>, (x, na(X), na(Y))) & Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))))) & ((Honest(Y) --> (Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) --> FirstSend(<Y,s2>, y, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))) & ((FirstSend(<Y,s2>, y, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) & Receive(<X,s1>,(y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))) --> (Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) < Receive(<X,s1>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))))))) --> ((Honest(Y) & Y ~= X) --> (Send(<X,s1>, (x,na(X), na(Y))) < Receive(<Y,s2>, (x, na(X), na(Y))) & Receive(<Y,s2>, (x, na(X), na(Y))) < Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) & Send(<Y,s2>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X)))) < Receive(<X,s1>, (y, na(Y), na(X), SIG[key(Y)](y,x,na(X))))))" by blast;
 
