 theory Samples = PCL:;

ML "set show_types";

(*EXAMPLE OF BASIC FORWARDS PROOF*)

lemma LEM1: "{P, X[send t1; receive t2], Send(X,t1) & Receive(X,t2)}";
proof -;
 have A: "{P,X[send t1],Send(X,t1)}" by (rule AA1S);
 have B: "{Send(X,t1),X[receive t2],Send(X,t1)}" by (rule P1S);
 have C: "{Send(X,t1),X[receive t2],Receive(X,t2)}" by (rule AA1R);
 from B C have D: "{Send(X,t1),X[receive t2],Send(X,t1) & Receive(X,t2)}" by (rule G1);
 from A D show E: "{P,X[send t1; receive t2],Send(X,t1) & Receive(X,t2)}" by (rule SEQ);
qed;

(*EXAMPLE OF FORWARD AND BACKWARDS PROOF, PROVE AND STATE MODES*)

lemma LEM2: "{P,X[new t; send t],Has(X,t) & Send(X,t)}";
proof -;
 have A: "{P,X[new t; send t],Has(X,t)}";
  apply (rule G3);
  apply (rule SEQ);
  apply (rule AA1N);
  apply (rule P1N);
  apply (blast);
  apply (rule ORIG);
  done;
 have B: "{P,X[new t; send t],Send(X,t)}";
  proof -;
  have C: "{P,X[new t],New(X,t)}" by (rule AA1N);
  have D: "{New(X,t),X[send t],Send(X,t)}" by (rule AA1S);
  from C D show "{P,X[new t; send t],Send(X,t)}" by (rule SEQ);
  qed;
  from A B show "{P,X[new t; send t],Has(X,t) & Send(X,t)}" by (rule G1);
qed;

(*EXAMPLE OF EXPLICIT VARIABLE INSTANTIATION, BACKWARDS REASONING IN STATE MODE, AND USING PREVIOUS LEMMA AS PROOF RULE*)

lemma LEM3: "{P,X[new t; send t; new t1; send t1],Has(X,t, t1) & Send(X,t1)}";
apply (rule_tac Q = "Has(X,t)" in SEQ);
proof -;
  apply_end (rule G3);
  prefer 2;
  apply_end blast;
  apply_end (rule AA1N);
  apply_end (rule ORIG);
  apply_end (rule SEQ);
  apply_end (rule P1H);
  have A: "{Has(X,t), X[new t1; send t1], Has(X,t)}" by (rule P1H);
  have B: "{Has(X,t), X[new t1; send t1], Has(X,t1) & Send(X, t1)}" by (rule LEM2);
  from A B have C: "{Has(X,t), X[new t1; send t1], Has(X, t) & Has(X,t1) & Send(X, t1)}" by (rule G1);
  have TAUT: "Has(X,t) --> Has(X,t)" by blast;
  have D: "Has(X,t) & Has(X,t1) --> Has(X, t, t1)" by (rule TUP);
  then have E: "Has(X, t) & Has(X,t1) & Send(X, t1) --> Has(X,t , t1) & Send(X,t1)" by blast;
  from C TAUT E show F: "{Has(X,t),X[new t1;send t1],Has(X,t , t1) & Send(X,t1)}" by (rule G3);
qed;

(*EXAMPLE OF EXISTENTIAL QUANITFICATION, THREAD EXPANDED OUT TO INCLUDE NAME AND SESSION ID, SIG AND ENC*)

lemma LEM4: "{(EX m. Send(<Y,s2>,  m) < Receive(<X, s1>, m)), <X,s1>[new x; send x,y, na(Y), na(X); receive na(Y), na(X), z; match z/SIG[key(Y)](y,na(X),na(Y))], Honest(X) & Decrypt(<Y,s2>, ENC[key(X)](x)) --> Y = X}";
apply (rule G4);
apply (rule SEC);;
done;



